/* ************************************************************ player.h *** *
 * $B2hA|%W%l!<%d$K4X$9$k4X?t(B $B%X%C%@%U%!%$%k(B
 *
 * Copyright (C) 2001-2003 Yasuyuki SUGAYA <sugaya@suri.it.okayama-u.ac.jp>
 * Okayama University
 *                                  Time-stamp: <2002-01-20 16:44:50 sugaya>
 * ************************************************************************* */
#ifndef	__PLAYER_H__
#define	__PLAYER_H__

typedef struct _IconButton {
  GdkPixmap	*pixmap;
  gint		width;
  gint		height;
  gint		cx;
  gint		cy;    
  gint		x;
  gint		y;
  gint		w;
  gint		h;
  gint		area;
} IconButton;

typedef struct _ButtonData {
  GdkPixmap	*pixmap;
  gint		cx;
  gint		cy;
  gint		x;
  gint		y;
  gint		w;
  gint		h;
  gint		area;  
} ButtonData;

typedef struct _ItemData {
  GdkPixmap	*pixmap;
  gint		sections;
  gint		cx;
  gint		cy;
  gint		w;
  gint		h;
  gint		area;  
} ItemData;

typedef struct _SliderData {
  GdkPixmap	*pixmap;
  gint		cx;
  gint		cy;
  gint		x;
  gint		y;
  gint		w;
  gint		h;
  gint		prelight;
  gint		verticle;
  gint		reversed;
  gint		handle_width;
  gint		handle_height;
  gint		position;
  gint		pushed;
  gint		prelit;
  void		(*press_func)   (float);
  void		(*release_func) (float);
  void		(*move_func)    (float);
  ItemData	*item;
  gint		area;  
} SliderData;

typedef struct _FontData {
  GdkPixmap	*pixmap;
  gint		length;
  gint		char_width;
  gint		char_height;
  gint		cx;
  gint		cy;
  gint		x;
  gint		y;
  gint		w;
  gint		h;
  gchar		*text;
  gint		offset;
  gint		scroll;
  gint		extended;
  gint		area;
} FontData;

typedef struct _NumberData {
  GdkPixmap	*pixmap;
  gint		cx;
  gint		cy;
  gint		w;
  gint		h;
  gint		area;
} NumberData;

typedef struct _SkinData {
  GdkPixmap	*background[4];
  GdkBitmap	*mask[5];
  ButtonData	*play_button;
  ButtonData	*back_button;
  ButtonData	*next_button;
  ButtonData	*prev_button;
  ButtonData	*stop_button;
  ButtonData	*rept_button;
  ButtonData	*exit_button;
  ItemData	*rept_item;
  FontData	*font;
  NumberData	*digit;
  SliderData	*slider;
  gint		cx;
  gint		cy;
  gint		cw;
  gint		ch;
} SkinData;

GtkWidget*	player_new		(gchar		*skin_data);
void		player_sync_to_skin 	(GtkWidget	*window);
void		player_update_window 	(void);

#endif /* __PLAYER_H__ */

/* ***************************************************** End of player.h *** */
